." This manual page describes part of the Morphological Analyser project
." developed at the Universities of Cambridge and Edinburgh.
." This page was written by Alan W. Black 
." awb@uk.ac.edinburgh.aiva
." This file should be placed in /usr/man/manl/dci.l
." Not to be used for military purposes
." Copyright A Black G Ritchie S Pulman G Russell 1987
.TH DCI local  "12 July 1987"
.SH NAME
dci \- dictionary command interpreter 
.SH SYNOPSIS
.B dci
[ dir ]    
.SH DESCRIPTION
.LP
.ul
dci
is a command interpreter for a Dictionary and Morphological Analyser
system developed at the Universities of Cambridge and Edinburgh.  It
allows the development of dictionaries and rules used to analyse words.
The advantage of this dictionary is that the dictionary entries are
.ul
morphemes
and rules can be written to described their concatenation, e.g. when
entries such as "move" "+ing" "apply" and "+ation" are entered rules
can be written that allow the analyser to find "moving" and "application".
.LP
For full details see
.ul
Dictionary and Morphological Analyser User Manual.
If 
.ul
dir
is specified the code is loaded from that directory.  If no directory
is specified the directory search path is: current directory;
value of the environment variable "usemap" if specified; and the lisp
library directory.
.LP
See section 9 in the User Manual for installation procedure.
.LP
This command and its related ones are written in Franz LISP and can
run only if opus 38 or 42 is installed on your machine.
.SH AUTHORS
.nf
Graeme Ritchie, Department of AI, University of Edinburgh
Steve Pulman, Computer Laboratory, University of Cambridge
Graham Russell, Computer Laboratory, University of Cambridge
Alan Black, Department of AI, University of Edinburgh
.SH FILES
.nf
$usemap represents the directory containing the analyser files

$usemap/dci             UNIX level command 
$usemap/doc             manuals
$usemap/examples/       sample user files
$usemap/src/            directory of source code
$usemap/common/         common lisp compatibility files
.SH "SEE ALSO"
mksp(l), mkgram(l), mklex(l), 
.SH BUGS
.LP
Please report any errors to Graeme Ritchie at graeme@uk.ac.edinburgh.edai
