." This manual page describes part of the Morphological Analyser project
." developed at the Universities of Cambridge and Edinburgh.
." This page was written by Alan W. Black 
." awb@uk.ac.edinburgh.aiva
." This file should be placed in /usr/man/manl/mkgram.l
." Not to be used for military purposes 
." Copyright A Black G Ritchie S Pulman G Russell 1987 
.TH MKGRAM local  "12 July 1987"
.SH NAME
mkgram \- compile a word grammar for morphological analyser
.SH SYNOPSIS
.B mkgram
file-header
.SH DESCRIPTION
.LP
.ul
mkgram
takes the file <file-header>.gr containing a word grammar definition
and
compiles it into the file <file-header>.gr.ma.
The exact format of the file is described in
.ul
Dictionary and Morphological Analyser User Manual.
An error is given
if no parameter is given or if <file-header>.le does not exist.
.LP
This forms part of the Morphological Analyser and Dictionary Project
software developed at Universities of Cambridge and Edinburgh.  
.PP
The grammar is specified in an extended context free notation based
on GPSG.  The grammar is used to specify which morphemes can be
validly combined.  e.g. "walk" and "+ing" are valid but "walk" 
and "+ly" is not.
.PP
This command and its related ones are written in Franz LISP and can
only run if opus 38 or 42 is installed on your machine.
.SH AUTHORS
.nf
Graeme Ritchie, Department of AI, University of Edinburgh
Steve Pulman, Computer Laboratory, University of Cambridge
Graham Russell, Computer Laboratory, University of Cambridge
Alan Black, Department of AI, University of Edinburgh
.SH FILES
.nf
$usemap represents the directory containing the analyser files

$usemap/mkgram          UNIX level command 
$usemap/src/            directory of source code
.SH "SEE ALSO"
dci(l), mksp(l), mklex(l), 
.SH BUGS
.LP
Please report any errors to Graeme Ritchie at graeme@uk.ac.edinburgh.edai
.LP
Currently there is no way to change the output file name 
