." This manual page describes part of the Morphological Analyser project
." developed at the Universities of Cambridge and Edinburgh.
." This page was written by Alan W. Black 
." awb@uk.ac.edinburgh.aiva
." This file should be placed in /usr/man/manl/mklex.l
." Not to be used for military purposes 
." Copyright A Black G Ritchie S Pulman G Russell 1987 
.TH MKLEX local  "12 July 1987"
.SH NAME
mklex \- compile a lexicon for morphological analyser
.SH SYNOPSIS
.B mklex
file-header
.SH DESCRIPTION
.LP
.ul
mklex
takes the file <file-header>.le containing a lexicon definition and
compiles it into the files <file-header>.le.ma and <file-header>.en.ma
which contain the lexicon index tree and the expanded lexical entries
respectively.  The exact format of the file is described in
.ul
Dictionary and Morphological Analyser User Manual.
An error is given
if no parameter is given or if <file-header>.le does not exist.
.LP
This forms part of the Morphological Analyser and Dictionary Project
software developed at Universities of Cambridge and Edinburgh.  
.PP
The lexicon contains what are termed 
.ul
morpheme
entries such as "move" "boy" "+s" and "+ed", (the spelling rules and
grammar rules form the other parts of the system).
As well as the actual lexical entries the lexicon 
definition file contains expansion rules that can flesh out simple
entries.
.PP
This command and its related ones are written in Franz LISP and can
run only if opus 38 or 42 is installed on your machine.
.SH AUTHORS
.nf
Graeme Ritchie, Department of AI, University of Edinburgh
Steve Pulman, Computer Laboratory, University of Cambridge
Graham Russell, Computer Laboratory, University of Cambridge
Alan Black, Department of AI, University of Edinburgh
.SH FILES
.nf
$usemap represents the directory containing the analyser files

$usemap/mklex           UNIX level command 
$usemap/src/            directory of source code
.SH "SEE ALSO"
dci(l), mksp(l), mkgram(l), 
.SH BUGS
.LP
If you are compiling large dictionaries be prepared to wait for a
long time.  A dictionary of 6500 morphemes takes around 1 hour on
a VAX 750 (depending on the type and number of lexical rules).
.LP
Please report any errors to Graeme Ritchie at graeme@uk.ac.edinburgh.edai
.LP
Currently there is no way to change the output file name 
